<template>
  <div class="el-tree">
    <header-breadcrumb
      title="login"
      class="bg-background3"
      style="font-size: 16px; height: 54px !important"
    />
    <div class="w-full p-5 mx-auto">
      <el-form
        ref="loginFormRef"
        label-position="top"
        :model="loginFormData"
        :rules="loginRules"
        :validate-on-rule-change="false"
        class="w-full mx-auto"
      >
        <el-form-item :label="$t('username')" prop="Username">
          <el-input
            v-model="loginFormData.Username"
            :placeholder="$t('username')"
            type="text"
          />
        </el-form-item>
        <el-form-item :label="$t('password')" prop="Password">
          <el-input
            v-model="loginFormData.Password"
            show-password
            :placeholder="$t('password')"
            type="password"
          />
        </el-form-item>
        <el-form-item class="forgot-password-form-item">
          <auth-forgot-password-modal :fullscreen="true" />
        </el-form-item>
        <template class="flex justify-center">
          <div class="mt-10">
            <el-button
              :disabled="isLoginProccessing"
              type="danger"
              round
              @click="submitLogin(loginFormRef)"
              >{{ $t("submit") }}</el-button
            >
          </div>
        </template>
      </el-form>
      <p
        v-if="!register.IsHidden"
        class="mt-4 text-sm font-normal leading-4 text-center fc-text"
      >
        {{ $t("you_do_not_have_account_yet") }}?
        <nuxt-link class="text-primary" :id="ID.SIGNUP" to="/register">{{
          $t("joinnow")
        }}</nuxt-link>
      </p>
      <theme-common-telegram-login-button
        :is-show="isTelegramBotSetup"
        :username="telegramBotUsername"
        @callback="telegramCallbackFunction"
      />
    </div>
  </div>
</template>

<script lang="ts">
import { computed, defineComponent } from "vue";
import { useRoute, useRouter } from "vue-router";
import useLogin from "@/composables/useLogin";
import useOnBack from "@/composables/useOnBack";

export default defineComponent({
  name: "Login",
  setup() {
    const {
      loginFormRef,
      loginFormData,
      loginRules,
      submitLogin,
      isLoginProccessing,
      register,
      isTelegramBotSetup,
      telegramBotUsername,
      checkLoginTelegramSetup,
      telegramCallbackFunction,
    } = useLogin();
    checkLoginTelegramSetup();
    const { previousRoute } = useOnBack();
    const route = useRoute();
    const router = useRouter();
    const backRoute = computed(() =>
      previousRoute.value === "" ? "HomeInitial" : "Profile"
    );
    const goBack = () => {
      if (route.matched[0].name !== "HelpCenter") {
        router.push({ name: backRoute.value });
      } else {
        router.go(-1);
      }
    };
    return {
      loginFormRef,
      loginFormData,
      loginRules,
      submitLogin,
      isLoginProccessing,
      goBack,
      register,
      telegramCallbackFunction,
      isTelegramBotSetup,
      telegramBotUsername,
    };
  },
});
</script>
<style scoped>
.text-primary {
  color: var(--primary);
}
:deep(button.el-button) {
  width: 142px;
  height: 40px;
  background-color: var(--primary);
  border: none;
}
:deep(.el-input__inner) {
  height: 48px;
  border-radius: 8px;
}
:deep(.el-button span) {
  @apply text-sm font-bold leading-4;
}
</style>
